<template>
  <a-list-layout
    ref="pageRef"
  >
    <template #search>
      <pro-query :searchParam="searchParam" @on-search="search"></pro-query>
    </template>
      <!-- 通道列表 -->
    <pro-table ref="tableRef" :fetch="fetch" :columns="columns" :toolbar="toolbar" :operate="operate"
      :param="state.param" :pagination="pagination"
      :row-selection="{ selectedRowKeys: state.selectedRowKeys, onChange: onSelectChange }">
    </pro-table>
    <save :visible="state.visibleSave" @close="closeSave"></save>
    <edit :visible="state.visibleEdit" @close="closeEdit" :record="state.recordEdit"></edit>
    <addConfig :visible="state.visibleSave" @close="closeSave"></addConfig>
    <info :visible="state.visibleInfo" @close="closeInfo" :record="state.recordInfo"></info>
  </a-list-layout>
</template>

<script>
  import save from './modal/save.vue';
  import edit from './modal/edit.vue';
  import info from './modal/info.vue';
  import {
    message,
    Modal as modal
  } from '@hwork/ant-design-vue';
  import {
    ExclamationCircleOutlined
  } from '@ant-design/icons-vue';
  import {
    page,
    change,
    remove,
    removeBatch
  } from "@/api/wms/track";
  import {
    reactive,
    createVNode,
    ref
  } from 'vue';

  const removeKey = "remove";
  const removeBatchKey = "removeBatch";

  export default {
    components: {
      save,
      edit,
      info,
    },
    setup() {

      const tableRef = ref();

      const switchFormat = {
        yes: true,
        no: false,
        event: function(value, record) {
          record.status = record.status == false ? true : false;
          change({
            "id": record.id,
            "status": record.status,
            "equipStatus": record.equipStatus
          })
          tableRef.value.reload()
          return value;
        }
      }

      /// 列配置
      const columns = [{
        dataIndex: "index",
        key: "index",
        title: "序号",
        width: 60,
        fixed: 'left',
        align: 'center'
      },
      {
          dataIndex: "trackCode",
          key: "trackCode",
          title: "通道号",
          width: 100,
          sorter:true,
          showSearch:true
        },
        {
          dataIndex: "sourceLoc",
          key: "sourceLoc",
          title: "WMS源位置",
          width: 100,
          sorter:true,
          showSearch:true
        },
        {
          dataIndex: "targetLoc",
          key: "targetLoc",
          title: "WMS目标位置",
          width: 100,
          sorter:true,
          showSearch:true
        },
        {
          dataIndex: "equipCode",
          key: "equipCode",
          title: "关键设备",
          width: 100,
          sorter:true,
          showSearch:true
        },
        /* {
          dataIndex: "status",
          key: "status",
          title: "WMS状态",
          switch: switchFormat,
          width: 100,
        }, */
        {
          dataIndex: "equipStatus",
          key: "equipStatus",
          title: "WCS状态",
          dictionary: {
            type: 'tag',
            code: 'equipStatus'
          },
          width: 100,
        },
        {
          dataIndex: "remark",
          key: "remark",
          title: "备注信息",
          width: 150,
          sorter:true,
          showSearch:true
        }
      ];

      /// 数据来源 [模拟]
      const fetch = async (param) => {
        var response = await page(param);
        return {
          total: response.data.total,
          data: response.data.record,
        };
      };

      /// 删除配置
      const removeMethod = (record) => {
        message.loading({
          content: "提交中...",
          key: removeKey
        });
        remove({
          "id": record.id
        }).then((response) => {
          if (response.success) {
            message.success({
              content: "删除成功",
              key: removeKey,
              duration: 1
            })
            tableRef.value.reload()
          } else {
            message.error({
              content: "删除失败",
              key: removeKey,
              duration: 1
            })
          }
        })
      }

      const removeBatchMethod = (ids) => {
        modal.confirm({
          title: '您是否确定要删除选择通道?',
          icon: createVNode(ExclamationCircleOutlined),
          okText: '确定',
          cancelText: '取消',
          onOk() {
            message.loading({
              content: "提交中...",
              key: removeBatchKey
            });
            removeBatch({
              "ids": ids
            }).then((response) => {
              if (response.success) {
                message.success({
                  content: "删除成功",
                  key: removeBatchKey,
                  duration: 1
                })
                tableRef.value.reload()
              } else {
                message.error({
                  content: "删除失败",
                  key: removeBatchKey,
                  duration: 1
                })
              }
            })
          }
        });
      }

      /// 工具栏
      const toolbar = [{
          label: "新增",
          event: function() {
            state.visibleSave = true
          }
        },
        {
          label: "删除",
          event: function() {
            removeBatchMethod(state.selectedRowKeys)
          },
          type: 'danger'
        },
      ];

      /// 行操作
      const operate = [{
          label: "修改",
          event: function(record) {
            state.visibleEdit = true, state.recordEdit = record
          }
        },
        {
          label: "删除",
          isDel: true,
          delEvent: function(record) {
            removeMethod(record)
          }
        },
      ];

      /// 分页参数
      const pagination = {
        pageNum: 1,
        pageSize: 20,
        showSizeChanger: true, // 显示可改变每页条数
        pageSizeOptions: ["10", "20", "50", "100"], // 每页条数选项设置
        showTotal: total => `共 ${total} 条记录`, // 显示总条数
        showSizeChange: (current, pageSize) => (this.pageSize = pageSize) // 改变每页条数时更新显示
      }

      /// 外置参数 - 当参数改变时, 重新触发 fetch 函数
      const state = reactive({
        selectedRowKeys: [],
        param: {},
        visibleSave: false,
        visibleEdit: false,
        visibleInfo: false,
        recordEdit: {},
        recordInfo: {},
      })

      const searchParam = [{
          key: "trackCode",
          type: "input",
          label: "通道号"
        },
        {
          key: "sourceLoc",
          type: "input",
          label: "WMS源位置"
        },
        {
          key: "targetLoc",
          type: "input",
          label: "WMS目标位置"
        },
        // {
        //   key: "status",
        //   type: "select",
        //   label: "位置状态"
        // },
      ]

      const search = function(value) {
        state.param = value
      }

      const closeSave = function() {
        tableRef.value.reload();
        state.visibleSave = false
      }

      const closeEdit = function() {
        tableRef.value.reload();
        state.visibleEdit = false
      }

      const closeInfo = function() {
        state.visibleInfo = false
      }

      const onSelectChange = selectedRowKeys => {
        state.selectedRowKeys = selectedRowKeys;
      };

      return {
        state, // 状态共享
        fetch, // 数据回调
        toolbar, // 工具栏
        columns, // 列配置
        operate, // 行操作
        pagination, // 分页配置

        search,
        searchParam, // 查询参数

        closeSave,
        closeEdit,
        closeInfo,

        onSelectChange,
        tableRef
      };
    },
  };
</script>
